You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 
 

361 lines
13 KiB

  1. #!/bin/sh
  2. command -V gpg >/dev/null 2>&1 && GPG="gpg" || GPG="gpg2"
  3. [ -z ${PASSWORD_STORE_DIR+x} ] && PASSWORD_STORE_DIR="$HOME/.password-store"
  4. [ -r "$PASSWORD_STORE_DIR/.gpg-id" ] &&
  5. "$GPG" --list-secret-keys $(cat "$PASSWORD_STORE_DIR/.gpg-id") >/dev/null 2>&1 || {
  6. printf "\`pass\` must be installed and initialized to encrypt passwords.\\nBe sure it is installed and run \`pass init <yourgpgemail>\`.\\nIf you don't have a GPG public private key pair, run \`%s --full-gen-key\` first.\\n" "$GPG"
  7. exit
  8. }
  9. prefix="/usr/local"
  10. pass_prefix="mw-"
  11. muttdir="${XDG_CONFIG_HOME:-$HOME/.config}/mutt" # Main mutt config location
  12. accdir="$muttdir/accounts" # Directory for account settings
  13. maildir="${XDG_DATA_HOME:-$HOME/.local/share}/mail" # Location of mail storage
  14. namere="^[a-z_][a-z0-9_-]*$" # Regex to ensure viable username
  15. emailre=".+@.+\..+" # Regex to confirm valid email address
  16. muttshare="$prefix/share/mutt-wizard"
  17. mbsyncrc="${MBSYNCRC:-$HOME/.mbsyncrc}"
  18. mwconfig="$muttshare/mutt-wizard.muttrc"
  19. cachedir="${XDG_CACHE_HOME:-$HOME/.cache}/mutt-wizard"
  20. muttrc="$muttdir/muttrc"
  21. msmtprc="${XDG_CONFIG_HOME:-$HOME/.config}/msmtp/config"
  22. msmtplog="${XDG_CONFIG_HOME:-$HOME/.config}/msmtp/msmtp.log"
  23. MARKER="# mw-autogenerated"
  24. alias mbsync='mbsync -c "$mbsyncrc"'
  25. for x in "/etc/ssl/certs/ca-certificates.crt" "/etc/pki/tls/certs/ca-bundle.crt" "/etc/ssl/ca-bundle.pem" "/etc/pki/tls/cacert.pem" "/etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem" "/etc/ssl/cert.pem" "/usr/local/share/ca-certificates/"
  26. do
  27. [ -f "$x" ] && sslcert="$x" && break
  28. done || { echo "CA Certificate not found. Please install one or link it to /etc/ssl/certs/ca-certificates.crt" && exit 1 ;}
  29. getaccounts() { accounts="$(find "$accdir" -type f | grep -o "[0-9]-.*.muttrc" | sed "s/-/: /;s/\.muttrc$//" | sort -n)" ;}
  30. list() { getaccounts && [ -n "$accounts" ] && echo "$accounts" ;}
  31. getprofiles() { \
  32. unset msmtp_header msmtp_profile mutt_profile mbsync_profile
  33. msmtp_header="defaults
  34. auth on
  35. tls on
  36. tls_trust_file $sslcert
  37. logfile $msmtplog
  38. "
  39. msmtp_profile="account $fulladdr
  40. host $smtp
  41. port ${sport:-587}
  42. from $fulladdr
  43. user $login
  44. passwordeval \"pass $pass_prefix$fulladdr\"
  45. $tlsline
  46. "
  47. mbsync_profile="IMAPStore $fulladdr-remote
  48. Host $imap
  49. Port ${iport:-993}
  50. User $login
  51. PassCmd \"pass $pass_prefix$fulladdr\"
  52. AuthMechs LOGIN
  53. SSLType ${ssltype:-IMAPS}
  54. CertificateFile $sslcert
  55. MaildirStore $fulladdr-local
  56. Subfolders Verbatim
  57. Path ${XDG_DATA_HOME:-$HOME/.local/share}/mail/$fulladdr/
  58. Inbox ${XDG_DATA_HOME:-$HOME/.local/share}/mail/$fulladdr/INBOX
  59. Flatten .
  60. Channel $fulladdr
  61. Expunge Both
  62. Master :$fulladdr-remote:
  63. Slave :$fulladdr-local:
  64. Patterns * !\"[Gmail]/All Mail\"
  65. Create Both
  66. SyncState *
  67. MaxMessages ${maxmes:-0}
  68. ExpireUnread no
  69. # End profile
  70. "
  71. if [ -z "${online+x}" ]; then
  72. mutt_profile="# vim: filetype=neomuttrc
  73. # muttrc file for account $fulladdr
  74. set realname = \"$realname\"
  75. set from = \"$fulladdr\"
  76. set sendmail = \"msmtp -a $fulladdr\"
  77. alias me $realname <$fulladdr>
  78. set folder = \"$maildir/$fulladdr\"
  79. set header_cache = $cachedir/$fulladdr/headers
  80. set message_cachedir = $cachedir/$fulladdr/bodies
  81. set mbox_type = Maildir
  82. bind index,pager gg noop
  83. bind index,pager g noop
  84. bind index,pager M noop
  85. bind index,pager C noop
  86. bind index gg first-entry
  87. macro index o \"<shell-escape>mw -y $fulladdr<enter>\" \"run mbsync to sync $fulladdr\"
  88. unmailboxes *
  89. "
  90. else
  91. mutt_profile="# vim: filetype=neomuttrc
  92. # muttrc file for account $fulladdr
  93. set realname = \"$realname\"
  94. set from = \"$fulladdr\"
  95. set sendmail = \"msmtp -a $fulladdr\"
  96. alias me $realname <$fulladdr>
  97. set folder = \"imaps://$login@$imap:${iport:-993}\"
  98. set imap_user = \"$login\"
  99. set header_cache = $cachedir/$fulladdr/headers
  100. set message_cachedir = $cachedir/$fulladdr/bodies
  101. set imap_pass = \"\`pass $pass_prefix$fulladdr\`\"
  102. set mbox_type = Maildir
  103. set ssl_starttls = yes
  104. set ssl_force_tls = yes
  105. bind index,pager gg noop
  106. bind index,pager g noop
  107. bind index,pager M noop
  108. bind index,pager C noop
  109. bind index gg first-entry
  110. unmailboxes *
  111. "
  112. fi
  113. }
  114. parsedomains(){ serverinfo="$(grep "^${fulladdr#*@}" "$muttshare/domains.csv" 2>/dev/null)"
  115. [ -z "$serverinfo" ] && serverinfo="$(grep "$(echo "${fulladdr#*@}" | sed "s/\.[^\.]*$/\.\\\*/")" "$muttshare/domains.csv" 2>/dev/null)"
  116. IFS=, read -r service imapsugg iportsugg smtpsugg sportsugg <<EOF
  117. $serverinfo
  118. EOF
  119. imap="${imap:-$imapsugg}"
  120. smtp="${smtp:-$smtpsugg}"
  121. sport="${sport:-$sportsugg}"
  122. iport="${iport:-$iportsugg}"
  123. }
  124. delete() { if [ -z "${fulladdr+x}" ]; then
  125. echo "Select the account your would like to delete (by number):"
  126. list
  127. read -r input
  128. match="^$input:"
  129. else
  130. match=" $fulladdr$"
  131. getaccounts
  132. fi
  133. fulladdr="$(echo "$accounts" | grep "$match" | cut -f2 -d' ')"
  134. [ -z "$fulladdr" ] && echo "Invalid account name given." && return 1
  135. sed -ibu "/IMAPStore $fulladdr-remote$/,/# End profile/d" "$mbsyncrc" ; rm -rf "$mbsyncrc"bu
  136. rm -rf "${cachedir:?}/${fulladdr:?}" "$accdir/"[1-9]"-$fulladdr.muttrc"
  137. sed -ibu "/[0-9]-$fulladdr.muttrc/d" "$muttrc" ; rm -f "$muttrc"bu
  138. sed -ibu "/account $fulladdr/,/^\(\s*$\|account\)/d" "$msmtprc"; rm -f "$msmtprc"bu
  139. pass rm -f "$pass_prefix$fulladdr" >/dev/null 2>&1
  140. }
  141. askinfo() { \
  142. [ -z "$fulladdr" ] && echo "Give the full email address to add:" &&
  143. read -r fulladdr
  144. while ! echo "$fulladdr" | grep -qE "$emailre"; do
  145. echo "\`$fulladdr\` is not a valid email address. Please retype the address:"
  146. read -r fulladdr
  147. done
  148. { [ -z "$imap" ] || [ -z "$smtp" ] ;} && parsedomains
  149. [ -z "$imap" ] && echo "Give your email server's IMAP address (excluding the port number):" &&
  150. read -r imap
  151. [ -z "$smtp" ] && echo "Give your email server's SMTP address (excluding the port number):" &&
  152. read -r smtp
  153. [ "$sport" = 465 ] && tlsline="tls_starttls off"
  154. [ -z "$realname" ] && echo "Give the name you would like to be identified by on the email account:" &&
  155. read -r realname
  156. login="${login:-$fulladdr}"
  157. if [ -n "${password+x}" ]; then
  158. createpass
  159. else
  160. getpass
  161. fi
  162. }
  163. createpass() { echo "$password" > "$PASSWORD_STORE_DIR/$pass_prefix$fulladdr"
  164. "$GPG" -qer "$(cat "$PASSWORD_STORE_DIR/.gpg-id")" "$PASSWORD_STORE_DIR/$pass_prefix$fulladdr"
  165. rm -f "$PASSWORD_STORE_DIR/$pass_prefix$fulladdr" ;}
  166. writeinfo() { mkdir -p "$muttdir" "$accdir" "$cachedir/$fulladdr/bodies" "${XDG_CONFIG_HOME:-$HOME/.config}/msmtp" "$maildir/$fulladdr"
  167. # Get accounts and find the first missing account number (max. 9).
  168. getaccounts; for x in $(seq 1 9); do echo "$accounts" | grep -q "$x" || { export idnum="$x"; break ;}; done
  169. # Configure msmtprc for sending mail.
  170. [ ! -f "$msmtprc" ] && echo "$msmtp_header" > "$msmtprc"
  171. echo "$msmtp_profile" >> "$msmtprc"
  172. # On Ubuntu/Debian, a link is needed since they use an older version.
  173. command -V apt-get >/dev/null 2>&1 && ln -s "$msmtprc" "$HOME/.msmtprc" 2>/dev/null
  174. # Create the mbsync config file.
  175. mkdir -p "${mbsyncrc%/*}"
  176. echo "$mbsync_profile" >> "$mbsyncrc"
  177. # Create a muttrc for viewing mail.
  178. echo "$mutt_profile" > "$accdir/$idnum-$fulladdr.muttrc"
  179. [ ! -f "$muttrc" ] && echo "# vim: filetype=neomuttrc" > "$muttrc"
  180. ! grep -q "^source.*mutt-wizard.muttrc" "$muttrc" && echo "source $mwconfig $MARKER" >> "$muttrc"
  181. ! grep "^source.*.muttrc" "$muttrc" | grep -qv "$mwconfig" && echo "source $accdir/$idnum-$fulladdr.muttrc $MARKER" >> "$muttrc"
  182. echo "macro index,pager i$idnum '<sync-mailbox><enter-command>source $accdir/$idnum-$fulladdr.muttrc<enter><change-folder>!<enter>;<check-stats>' \"switch to $fulladdr\" $MARKER" >> "$muttrc"
  183. notmuchauto # Create a notmuch config file if not present already.
  184. }
  185. getpass() { while : ; do pass rm -f "$pass_prefix$fulladdr" >/dev/null 2>&1
  186. pass insert "$pass_prefix$fulladdr" && break; done ;}
  187. formatShortcut() { toappend="$toappend
  188. macro index,pager g$1 \"<change-folder>=$3<enter>\" \"go to $2\" $MARKER
  189. macro index,pager M$1 \";<save-message>=$3<enter>\" \"move mail to $2\" $MARKER
  190. macro index,pager C$1 \";<copy-message>=$3<enter>\" \"copy mail to $2\" $MARKER" >> "$accdir/$idnum-$fulladdr.muttrc" ;}
  191. setBox() { toappend="$toappend
  192. set $1 = \"+$2\" $MARKER" ;}
  193. getboxes() { [ -n "${force+x}" ] && mailboxes="INBOX
  194. Drafts
  195. Junk
  196. Trash
  197. Sent
  198. Archive" && return 0
  199. if mailboxes="$(mbsync -l "$fulladdr" | sed 's/\//./')" >/dev/null 2>&1 && [ -n "$mailboxes" ]; then
  200. [ "$accounttype" = "online" ] && sed -ibu "/IMAPStore $fulladdr-remote$/,/# End profile/d" "$mbsyncrc" ; rm -f "$mbsyncrc"bu
  201. return 0
  202. else
  203. echo "$mailboxes"
  204. printf "\033[31m\033[31mLog-on not successful.\033[0m\\nIt seems that either you inputted the wrong password or server settings, or there are other requirements for your account out of the control of mutt-wizard.\\n"
  205. return 1
  206. fi ;}
  207. finalize() { echo "$mailboxes" | xargs -I {} mkdir -p "$maildir/$fulladdr/{}/cur" "$maildir/$fulladdr/{}/tmp" "$maildir/$fulladdr/{}/new"
  208. sed -ibu "/$MARKER/d" "$accdir/$idnum-$fulladdr.muttrc" ; rm -f "$accdir/$idnum-$fulladdr.muttrcbu"
  209. toappend="mailboxes $(echo "$mailboxes" | sed "s/^/\"=/;s/$/\"/" | paste -sd ' ' )"
  210. for x in $mailboxes; do
  211. case $x in
  212. *[Ii][Nn][Bb][Oo][Xx]*) formatShortcut i inbox "$x"; setBox spoolfile "$x" ;;
  213. *[Ss][Ee][Nn][Tt]*) setBox record "$x"; formatShortcut s sent "$x" ;;
  214. *[Dd][Rr][Aa][Ff][Tt][Ss]*) setBox postponed "$x"; formatShortcut d drafts "$x" ;;
  215. *[Tt][Rr][Aa][Ss][Hh]*) formatShortcut t trash "$x"; setBox trash "$x" ;;
  216. *[Jj][Uu][Nn][Kk]*) formatShortcut j junk "$x" ;;
  217. *[Aa][Rr][Cc][Hh][Ii][Vv][Ee]*) formatShortcut a archive "$x" ;;
  218. *[Ss][Pp][Aa][Mm]*) formatShortcut S spam "$x" ;;
  219. esac
  220. done
  221. echo "$toappend" >> "$accdir/$idnum-$fulladdr.muttrc"
  222. [ -z "${online+x}" ] && printf "\033[33mYou should now be able to run \`\033[32mmw -y %s\033[33m\` to begin to download your mail.\033[0m\\n" "$fulladdr"
  223. command -V urlview >/dev/null 2>&1 && [ ! -f "$HOME/.urlview" ] && echo "COMMAND \$BROWSER" > "$HOME/.urlview"
  224. return 0 ;}
  225. syncwrapper() { mbsync "${1:--a}" &
  226. ( kill -46 "$(pidof "${STATUSBAR:-dwmblocks}")" >/dev/null 2>&1 ) 2>/dev/null
  227. wait
  228. ( kill -46 "$(pidof "${STATUSBAR:-dwmblocks}")" >/dev/null 2>&1 ) 2>/dev/null
  229. notmuch new ;}
  230. notmuchauto() { \
  231. [ -z "$NOTMUCH_CONFIG" ] && NOTMUCH_CONFIG="$HOME/.notmuch-config"
  232. [ -f "$NOTMUCH_CONFIG" ] && return 0
  233. nmbasic="[database]
  234. path=$maildir
  235. [user]
  236. name=$realname
  237. primary_email=$fulladdr
  238. [new]
  239. tags=unread;inbox;
  240. ignore=.mbsyncstate;.uidvalidity
  241. [search]
  242. exclude_tags=deleted;spam;
  243. [maildir]
  244. synchronize_flags=true
  245. [crypto]
  246. gpg_path=$GPG"
  247. echo "$nmbasic" > "$NOTMUCH_CONFIG" ;}
  248. setact() { if [ -n "${action+x}" ] && [ "$action" != "$1" ]; then
  249. echo "Running $1 with $action..."
  250. echo "Incompatible options given. Only one action may be specified per run."
  251. return 1
  252. else
  253. action="$1"
  254. fi; }
  255. trap 'echo -e "\033[0m\n"; exit' INT ABRT
  256. while getopts "fplhdYD:y:i:I:s:S:u:a:n:x:" o; do case "${o}" in
  257. l) setact list || exit 1 ;;
  258. d) setact delete || exit 1 ;;
  259. D) setact delete || exit 1 ; fulladdr="$OPTARG" ;;
  260. y) setact sync || exit 1 ; fulladdr="$OPTARG" ;;
  261. Y) setact sync || exit 1 ;;
  262. a) setact add || exit 1 ; fulladdr="$OPTARG" ;;
  263. i) setact add || exit 1 ; imap="$OPTARG" ;;
  264. I) setact add || exit 1 ; iport="$OPTARG" ;;
  265. s) setact add || exit 1 ; smtp="$OPTARG" ;;
  266. S) setact add || exit 1 ; sport="$OPTARG" ;;
  267. u) setact add || exit 1 ; login="$OPTARG" ;;
  268. n) setact add || exit 1 ; realname="$OPTARG" ;;
  269. m) setact add || exit 1 ; maxmes="$OPTARG" ;;
  270. o) setact add || exit 1 ; online=True ;;
  271. f) setact add || exit 1 ; force=True ;;
  272. x) setact add || exit 1 ; password="$OPTARG" ;;
  273. p) echo "NOTE: Protonmail users must install and configure Protonmail Bridge first for the first sync to work."
  274. proton=True
  275. imap="127.0.0.1"
  276. iport="1143"
  277. smtp="127.0.0.1"
  278. sport="1025"
  279. ssltype="None"
  280. tlsline="tls_fingerprint $(msmtp --serverinfo --host=$smtp --port=$sport --tls --tls-certcheck=off | awk '/SHA256:/ {print $2}')"
  281. setact add || exit 1
  282. ;;
  283. *) cat << EOF
  284. mw: mutt-wizard, auto-configure email accounts for mutt
  285. including downloadable mail with \`isync\`.
  286. Main actions:
  287. -a your@email.com Add an email address
  288. -l List email addresses configured
  289. -d Remove an already added address
  290. -D your@email.com Force remove account without confirmation
  291. -y your@email.com Sync mail for account by name
  292. -Y Sync mail for all accounts
  293. Options allowed with -a:
  294. -u Account login name if not full address
  295. -n "Real name" to be on the email account
  296. -i IMAP server address
  297. -I IMAP server port
  298. -s SMTP server address
  299. -S SMTP server port
  300. -x Password for account (recommended to be in double quotes)
  301. -p Install for a Protonmail account.
  302. -o Configure address, but keep mail online.
  303. -b Assume typical English mailboxes without attempting log-on.
  304. NOTE: Once at least one account is added, you can run
  305. \`mbsync -a\` to begin downloading mail.
  306. To change an account's password, run \`pass edit ${pass_prefix}your@email.com\`.
  307. EOF
  308. exit 1
  309. ;;
  310. esac done
  311. ! command -v mbsync >/dev/null && [ -z "${force+x}" ] && printf "\`mbsync (isync package)\` must be installed to run mutt-wizard.\\n" && exit
  312. case "$action" in
  313. list) list ;;
  314. add) askinfo && getprofiles && writeinfo && getboxes && finalize || { delete ; exit 1 ;} ;;
  315. delete) delete $fulladdr ;;
  316. sync) syncwrapper $fulladdr ;;
  317. esac